<?php
/**
 * @package Joomla
 * @subpackage VFM
 * @version $Id: admin.vfm.php 6 2006-05-10 20:13:21Z tvlgiao $
 * @author Giao Trinh (tvlgiao@yahoo.com)
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * Joomla! is free software and parts of it may contain or be derived from the
 * GNU General Public License or other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

define ('VFM_GROUP_PREFIX', 'vfm');

# include support libraries
#require_once( $mainframe->getPath( 'admin_html' ) );

# include some helper classes here
#require_once dirname(__FILE__) . "/example.class.php";

# TODO: create some helper objects here...
#tblExample = &new mosDBTable_Example($database);


# handle the task
$task = mosGetParam( $_REQUEST, 'task', '' );
$act = mosGetParam( $_REQUEST, 'act', '' );
$errormsg = mosGetParam( $_REQUEST, 'errormsg', '' );
$successmsg = mosGetParam( $_REQUEST, 'successmsg', '' );


$database->setQuery("SELECT * FROM #__components WHERE `option`='$option'");
if ( !($database->loadObject(&$row)) ) {
	echo $database->getErrorMsg();
	return;
}
$conf = unserialize($row->params);

switch ($act) {
	case 'group':
		switch ($task) {
			case 'ajaxEditGroup':
				vfm_group_ajaxeditgroup();
				break;
				
			case 'ajaxSave':
				vfm_group_ajaxsave();
				break;
			
			case 'ajaxAddGroup':
				vfm_group_ajaxaddgroup();
				break;
				
			case 'ajaxRemoveGroup':
				vfm_group_ajaxremovegroup();
				break;
				
			default:
				vfm_group_default();
				break;
		}
		break;
		
	case 'config':
	default:
		switch ($task) {
			case 'save':
				vfm_config_save();
				break;
				
			default:
				vfm_config_default();
				break;
		}
	
}


function vfm_group_default() {
	global $option, $act, $task, $database, $mosConfig_live_site;
	
	$database->setQuery("SELECT * FROM #__vfm_groups");
	$groups = $database->loadObjectList();
	
	$database->setQuery("SELECT * FROM #__users");
	$users = $database->loadObjectList();

	include dirname(__FILE__) . '/tpl/admin.group_default.php';
}

function vfm_group_ajaxeditgroup() {
	global $option, $act, $task, $database;
	
	$gid = $database->getEscaped($_REQUEST['gid']);
	
	$database->setQuery("SELECT * FROM #__vfm_groups WHERE gid='$gid'");
	$database->LoadObject(&$group);
	
	$database->setQuery("
				SELECT u.id FROM #__vfm_link_users_groups AS ug
				INNER JOIN #__users AS u ON ug.user_id=u.id
				INNER JOIN #__vfm_groups AS g ON ug.gid=g.gid
				WHERE ug.gid='$gid' ");
	$users = $database->loadObjectList();
	$list = array();
	foreach ($users as $u) $list[] = $u->id;
	
	$json = '{';
	$json .= 'uid: ' . '["' . implode('","', $list) . '"], ';
	$json .= "gid: '$gid', ";
	$json .= "groupname: '$group->groupname'";
	$json .= '}';
	header( "X-JSON: $json");
	
	//include dirname(__FILE__) . '/tpl/admin.group_ajaxeditgroup.php';
	exit();
}

function vfm_group_ajaxsave() {
	global $option, $act, $task, $database;
	
	$gid = $database->getEscaped($_REQUEST['gid']);
	
	$_cid = $_REQUEST['cid'];
	if (!is_array($_cid)) $_cid = array();
	$values = array();
	foreach ($_cid as $i) {
		$values[] = "('" . intval($i) . "', '$gid')";
	}
	
	
	$database->setQuery("SELECT * FROM #__vfm_groups WHERE gid='$gid'");
	$database->LoadObject(&$group);
	if (!$group || !$group->gid) {
		echo 'group does not exist';
		exit();
	}

	$database->setQuery("DELETE FROM #__vfm_link_users_groups WHERE gid='$gid'");
	$database->query();
	
	if (count($values) > 0) {
		$database->setQuery("INSERT INTO #__vfm_link_users_groups (`user_id`, `gid`) 
							VALUES " . implode (",", $values) );
		$database->query();
	}
	echo 'changed successfully.';
	exit();
}

function vfm_group_ajaxaddgroup() {
	global $option, $act, $task, $database;
	
	$gid = $database->getEscaped(VFM_GROUP_PREFIX . $_REQUEST['gid']);
	$groupname = $database->getEscaped($_REQUEST['groupname']);
	
	$database->setQuery("SELECT * FROM #__vfm_groups WHERE `gid`='$gid'");
	$rows = $database->loadObjectList();
	if (count($rows) > 0) {
		header('X-JSON: "group name is existed"');
		exit();
	}
	
	$database->setQuery("INSERT INTO #__vfm_groups (`gid`, `groupname`) VALUES ('$gid', '$groupname')");
	if (!$database->query()) {
		header('X-JSON: "insert database error: ' . $database->getEscaped($database->getErrorMsg()) . '"');
		exit();
	}
	
	$database->setQuery("SELECT count(*) AS `count` FROM #__vfm_groups");
	$database->loadObject(&$row);
	$i = $row->count - 1;
	
	$row = '';
	$database->setQuery("SELECT * FROM #__vfm_groups WHERE `gid`='$gid'");
	$database->loadObject(&$row);
	
	include dirname(__FILE__) . "/tpl/admin._group.php";
	exit();

}


function vfm_group_ajaxremovegroup() {
	global $option, $act, $task, $database;
	$gid = $database->getEscaped($_REQUEST['gid']);
	$database->setQuery("DELETE FROM #__vfm_link_files_groups WHERE `gid`='$gid'");
	if (!$database->query()) {
		header('X-JSON: "remove failed"');
		exit();
	}
	$database->setQuery("DELETE FROM #__vfm_groups WHERE `gid`='$gid'");
	if (!$database->query()) {
		header('X-JSON: "remove failed"');
		exit();
	}
	
	echo "removed successful";
		exit();
}

function vfm_config_default() {
	global $conf, $option, $act, $task;
	
	include dirname(__FILE__) . '/tpl/admin.config_default.php';
}

function vfm_config_save() {
	global $conf, $option, $act, $database;
	$params = $_REQUEST['conf'];
	$params = $database->getEscaped(serialize($params));
	$database->setQuery("UPDATE #__components SET `params`='$params' WHERE `option`='$option'");
	$database->query();
	mosRedirect("index2.php?option=$option&act=$act&successmsg=" . urlencode("saved."));
}

?>