-- =============================================================================
-- Diagram Name: vnetcom-files-manager
-- Created on: 4/26/2006 4:43:44 PM
-- Diagram Version: 
-- =============================================================================



-- Drop table jos_vfm_files
DROP TABLE IF EXISTS `jos_vfm_files`;

CREATE TABLE `jos_vfm_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(50),
  `isfolder` tinyint(4),
  `view_count` int(11) DEFAULT '0',
  `parent` varchar(255) NOT NULL,
  PRIMARY KEY(`id`),
  INDEX `new_index0`(`parent`)
)
TYPE=MYISAM
ROW_FORMAT=default;

-- Drop table jos_vfm_groups
DROP TABLE IF EXISTS `jos_vfm_groups`;

CREATE TABLE `jos_vfm_groups` (
  `gid` varchar(50) NOT NULL,
  `groupname` varchar(255),
  PRIMARY KEY(`gid`)
)
TYPE=MYISAM
ROW_FORMAT=default;

-- Drop table jos_vfm_link_files_usertypes
DROP TABLE IF EXISTS `jos_vfm_link_files_usertypes`;

CREATE TABLE `jos_vfm_link_files_usertypes` (
  `file_id` int(11) NOT NULL DEFAULT '0',
  `usertype_id` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `permission` enum('view','admin','deny') NOT NULL DEFAULT 'deny',
  PRIMARY KEY(`file_id`, `usertype_id`),
  INDEX `FKIndex1`(`file_id`),
  INDEX `FKIndex2`(`usertype_id`)
)
TYPE=MYISAM
ROW_FORMAT=default;

-- Drop table jos_vfm_link_users_groups
DROP TABLE IF EXISTS `jos_vfm_link_users_groups`;

CREATE TABLE `jos_vfm_link_users_groups` (
  `user_id` tinyint(11) NOT NULL DEFAULT '0',
  `gid` varchar(50) NOT NULL,
  PRIMARY KEY(`user_id`, `gid`),
  INDEX `FKIndex1`(`user_id`),
  INDEX `FKIndex2`(`gid`)
)
TYPE=MYISAM
ROW_FORMAT=default;

-- Drop table jos_vfm_link_files_groups
DROP TABLE IF EXISTS `jos_vfm_link_files_groups`;

CREATE TABLE `jos_vfm_link_files_groups` (
  `file_id` int(11) NOT NULL DEFAULT '0',
  `gid` varchar(50) NOT NULL,
  `permission` enum('admin','view','deny') NOT NULL DEFAULT 'deny',
  PRIMARY KEY(`file_id`, `gid`),
  INDEX `FKIndex1`(`file_id`),
  INDEX `FKIndex2`(`gid`)
)
TYPE=MYISAM
ROW_FORMAT=default;






--
-- TEST
--

-- 
-- Dumping data for table `jos_vfm_files`
-- 

INSERT INTO `jos_vfm_files` VALUES (1, 'ebooks', 1, 0, '');
INSERT INTO `jos_vfm_files` VALUES (2, 'public_html', 1, 0, '');

INSERT INTO `jos_vfm_link_files_usertypes` VALUES (1, 3, 'view');
INSERT INTO `jos_vfm_link_files_usertypes` VALUES (2, 3, 'view');
INSERT INTO `jos_vfm_link_files_usertypes` VALUES (2, 1, 'admin');

-- 
INSERT INTO `jos_vfm_groups` VALUES ('vfmadmin', 'Administrator');
INSERT INTO `jos_vfm_groups` VALUES ('vfmdepartment1', 'Department 1');
INSERT INTO `jos_vfm_groups` VALUES ('vfmdepartment2', 'Department 2');

INSERT INTO `jos_vfm_link_users_groups` VALUES (66, 'vfmdepartment1');
INSERT INTO `jos_vfm_link_users_groups` VALUES (66, 'vfmdepartment2');

INSERT INTO `jos_vfm_link_files_groups` VALUES (2, 'vfmdepartment1', 'view');
INSERT INTO `jos_vfm_link_files_groups` VALUES (2, 'vfmdepartment2', 'deny');
