<?php
/**
* @version $Id: vfm.php 11 2006-05-21 04:21:30Z tvlgiao $
* @package Joomla
* @subpackage VFM
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

/** no direct access */
defined( '_VALID_MOS' ) or die( 'Restricted access' );

include dirname($mainframe->getPath('admin')) . '/VFM_Core.class.php';

$do = mosGetParam ($_REQUEST, 'do', '');

#
# TESTING
#
//$conf['rootdir'] = 'F:/home/tvlgiao';
//$conf['root_permission'] = 'view'; # 'deny', 'view', 'admin'
//$conf['debug'] = true;
//$conf['debug_output'] = 'vfm_debug.log.html';
//$conf['debug_output_ajax'] = 'vfm_debug_ajax.log.html';
//$conf['zip_filename'] = 'vfm';
//$conf['componentheading'] = 'File Manager';

/*
$conf['icons'] = array(
		'doc' => 'ms-word.gif',
		'xls' => 'excel-file.gif',
		'psd' => 'photoshop-file.gif',
		'ill' => 'illustrator-file.gif',
		'pdf' => 'pdf.gif',
		'swf' => 'flash-file.gif',
		'fla' => 'flash-file.gif',
		'htm' => 'dreamweaver-file.gif',
		'html' => 'dreamweaver-file.gif',
		'css' => 'dreamweaver-file.gif',
		'php' => 'dreamweaver-file.gif',
		'mov' => 'quicktime-movie-file.gif',
		'wmv' => 'window-media-file.gif',
		'wma' => 'window-media-file.gif',
		'avi' => 'window-media-file.gif',
		'mp4' => 'window-media-file.gif',
		'mid' => 'window-media-file.gif',
		'mp3' => 'mp3-music-file.gif',
		'zip' => 'zip-file.gif',
		'tar' => 'zip-file.gif',
		'gz' => 'zip-file.gif',
		'rar' => 'zip-file.gif',
		'exe' => 'exe-file.gif',
		'txt' => 'text-file.gif',
		'' => 'file.gif' );
*/

$database->setQuery("SELECT * FROM #__components WHERE `option`='$option'");
if ( !($database->loadObject(&$row)) ) {
	echo $database->getErrorMsg();
	return;
}
$conf = unserialize($row->params);

$mainframe->addCustomHeadTag('<link type="text/css" rel="stylesheet" href="'.$mosConfig_live_site.'/administrator/components/com_vfm/css/vfm.css" />');
$mainframe->addCustomHeadTag('<link type="text/css" rel="stylesheet" href="'.$mosConfig_live_site.'/administrator/components/com_vfm/css/editinplace.css" />');
$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.$mosConfig_live_site.'/administrator/components/com_vfm/js/prototype-1.5.0.js"></script>');
$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.$mosConfig_live_site.'/administrator/components/com_vfm/js/editinplace.js"></script>');

switch ($do) {
	case 'setadmin':
		vfm_do_setadmin();
		break;
		
	case 'setview':
		vfm_do_setview();
		break;
		
	case 'setdeny':
		vfm_do_setdeny();
		break;
		
	case 'settitle':
		vfm_do_settitle();
		break;
	
	case 'setdesc':
		vfm_do_setdesc();
		break;
		
	case 'zip':
		vfm_do_zip();
		break;
		
	case 'download':
		vfm_do_download();
		break;
	
	default:
		vfm_do_default();
		break;
}



function vfm_do_default() {
	global $database, $my, $conf, $option, $Itemid, $task, $mosConfig_live_site, $mosConfig_absolute_path;
	
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	if (!$vfm->open()) include dirname(__FILE__) . '/tpl/default_fail.php';
	
	$files = $folders = array();
	while ($vfm->read()) {
		if ($vfm->entry['basename'] == '.' || $vfm->entry['basename'] == '..') continue;
		if ($vfm->entry['type'] == 'dir') $folders[] = $vfm->entry;
		else $files[] = $vfm->entry;
	}
		
	include dirname(__FILE__) . '/tpl/default_success.php';

		
}

function vfm_do_setview() {
	global $conf;
	$conf['debug_output'] = $conf['debug_output_ajax'];
	
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$groups = explode(',', $_REQUEST['contents']);
	$result = $vfm->setPermission('view', $groups);
	if ($result === false) vfm_exit404();
	elseif ($result == '') vfm_end('<em>Set Viewers...</em>');
	else vfm_end($result);
	
}

function vfm_do_setadmin() {
	global $conf;
	$conf['debug_output'] = $conf['debug_output_ajax'];
	
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$groups = explode(',', $_REQUEST['contents']);
	$result = $vfm->setPermission('admin', $groups);
	if ($result === false) vfm_exit404();
	elseif ($result == '') vfm_end('<em>Set Admin...</em>');
	else vfm_end($result);
}

function vfm_do_setdeny() {
	global $conf;
	$conf['debug_output'] = $conf['debug_output_ajax'];
		
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$groups = explode(',', $_REQUEST['contents']);
	$result = $vfm->setPermission('deny', $groups);
	if ($result === false) vfm_exit404();
	elseif ($result == '') vfm_end('<em>Set Deny...</em>');
	else vfm_end($result);
}

function vfm_do_settitle() {
	global $conf;
	$conf['debug_output'] = $conf['debug_output_ajax'];
		
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$result = $vfm->setAttribute(array( 'title' => $_REQUEST['contents'] ));
	if ($result === false) vfm_exit404();
	elseif ($result->title == '') vfm_end(basename($vfm->dirname));
	else vfm_end($result->title);
}

function vfm_do_setdesc() {
	global $conf;
	$conf['debug_output'] = $conf['debug_output_ajax'];
		
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$result = $vfm->setAttribute(array( 'description' => $_REQUEST['contents'] ));
	if ($result === false) vfm_exit404();
	elseif ($result->description == '') vfm_end('Set Description...');
	else vfm_end($result->description);
}

function vfm_do_zip() {
	global $database, $my, $conf, $option, $Itemid, $task;
	$conf['debug_output'] = $conf['debug_output_ajax'];
	
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['dir']);
	$zip = &$vfm->zipChildren($_POST['select']);
	
	$filename = ($vfm->dirname ? basename($vfm->dirname) : $conf['zip_filename']) . '.zip';
	$content = $zip->file();
	$filesize = strlen($content);

	ini_set('zlib.output_compression', 'Off');
	header("Content-Type: application/force-download");
	header("Content-Disposition: attachment; filename=$filename");
	header("Content-length: $filesize");

	vfm_end( &$content );
}

function vfm_do_download() {
	global $database, $my, $conf, $option, $Itemid, $task;
	$conf['debug_output'] = $conf['debug_output_ajax'];
	
	$vfm = new VFM_Core($conf);
	$vfm->setDir($_REQUEST['file']);
	if (false === ($content = &$vfm->download())) return vfm_exit404();
	$filename = basename($vfm->dirname);
	$filesize = strlen($content);
	
	ini_set('zlib.output_compression', 'Off');
	header("Content-Type: application/force-download");
	header("Content-Disposition: attachment; filename=$filename");
	header("Content-length: $filesize");

	vfm_end( &$content );
}

function vfm_exit404() {
	header("Status: 404 Not Found");
	exit();
}

function vfm_end($content) {
	ob_clean();
	echo $content;
	ob_flush();
	exit();
}

?>